Attribute VB_Name = "Subs"
Option Explicit

Public Sub LoadSettings()
  'Fixe Einstellungen des ComPorts
  COMPort.COMPort = 0
  COMPort.Settings = "19200,N,8,1"
  COMPort.Handshake = comNone
  COMPort.InputMode = comInputModeText
  
  frmMain.Com.Settings = COMPort.Settings
  frmMain.Com.Handshaking = COMPort.Handshake
  frmMain.Com.InputMode = COMPort.InputMode
  
  
  'INI Datei festlegen
  Einstellungen.INIFile = "Einstellungen" '.ini wird automatisch angehngt
  
  'INI-Werte Laden
  COMPort.COMPort = INI_Eintrag_lesen(Einstellungen.INIFile, "Programm", "COMPort")
  Einstellungen.ReloadTime = INI_Eintrag_lesen(Einstellungen.INIFile, "Programm", "AkInterval")
  Einstellungen.Logging = INI_Eintrag_lesen(Einstellungen.INIFile, "Programm", "Logging")
  
  Hardware.Modul.Heizung.Adresse = INI_Eintrag_lesen(Einstellungen.INIFile, "Heizung", "Adresse") + ": "
  Hardware.Modul.regler.Adresse = INI_Eintrag_lesen(Einstellungen.INIFile, "Regler", "Adresse") + ": "
  
  'Hardwarebefehle zum Abfragen der Module einlesen
  Dim dummy As String
  Dim i As Integer
    
  'Heizung
  Do
    i = i + 1
    dummy = INI_Eintrag_lesen(Einstellungen.INIFile, "Heizung", "Abfrage" + Format(i))
    If dummy <> "" Then
      ReDim Preserve Hardware.Modul.Heizung.PollBefehle(i)
      Hardware.Modul.Heizung.PollBefehle(i) = dummy
    End If
  Loop Until dummy = ""
  
  'Regler
  Do
    i = i + 1
    dummy = INI_Eintrag_lesen(Einstellungen.INIFile, "Regler", "Abfrage" + Format(i))
    If dummy <> "" Then
      ReDim Preserve Hardware.Modul.regler.PollBefehle(i)
      Hardware.Modul.Heizung.PollBefehle(i) = dummy
    End If
  Loop Until dummy = ""
  
End Sub

Public Sub SaveSettings()
  Dim dummy As Integer
  'Einstellungen speichern
  INI_Eintrag_speichern Einstellungen.INIFile, "Programm", "COMPort", Format(COMPort.COMPort)
  INI_Eintrag_speichern Einstellungen.INIFile, "Programm", "AkInterval", Format(Einstellungen.ReloadTime)
  INI_Eintrag_speichern Einstellungen.INIFile, "Programm", "Logging", Format(Einstellungen.Logging)
End Sub

'Kleine Warteschleife
Public Sub Warten()
  Dim i As Double
  
  For i = 1 To 1000
    DoEvents
  Next i
End Sub

'Auf Serielle Schnittstelle warten
Public Function WaitSeriell() As String
  Dim i As Double
  Dim buffer As String
  Dim dummy As String
    
  For i = 1 To 1000
    DoEvents
  Next i
  Do
    i = i + 1
    DoEvents
    dummy = frmMain.Com.Input
    If dummy <> "" Then buffer = buffer + dummy
  Loop Until i = 100000 Or InStr(buffer, vbCr) 'Or buffer <> ""
  
  'Timeout?
  If i = 100000 Then buffer = ""
  'MsgBox buffer
  WaitSeriell = buffer
End Function

'Seriellen String senden
Public Sub SendString(buffer As String)
  Dim i As Integer
  Dim j As Integer

  frmMain.Com.Output = Chr(13)
  For j = 1 To 5000
    DoEvents
  Next j
  
  For i = 1 To Len(buffer)
    'Zeichen senden
    frmMain.Com.Output = Mid(buffer, i, 1)
    For j = 1 To 1000
      DoEvents
    Next j
  Next i
  frmMain.Com.Output = Chr(13)
  For j = 1 To 1000
    DoEvents
  Next j

End Sub
