Attribute VB_Name = "Global"

'Eigene Datentypen
Type COMPortVars
  COMPort As Integer
  Settings As String
  Handshake As Integer
  InputMode As Integer
End Type

Type SettingsVars
  ReloadTime As Integer
End Type

Type HeizungVars
  Adresse As String
  Befehl_Kesseltemp As String
  Befehl_Brennertemp As String
End Type

Type ReglerVars
  Adresse As String
  Befehl_Raumtemp As String
End Type

Type ModulVars
  Heizung As HeizungVars
  Regler As ReglerVars
End Type

Type TemperaturenVars
  Kessel As Double
  Brenner As Double
  Raum As Double
End Type

Type HardwareVars
  Modul As ModulVars
  Temperaturen As TemperaturenVars
End Type



'Globale Variablen
Global Const splashtime = 0                                     'Zeit die der Splash Screen stehen bleibt. Normal 2
Global Const INIFile = "Einstellungen"
Global COMPort As COMPortVars                                   'Einstellungen des ComPorts
Global Einstellungen As SettingsVars                            'Programmeinstellungen
Global Hardware As HardwareVars                                 'Hardwareeinstellungen
