Attribute VB_Name = "Subs"
Option Explicit

Public Sub LoadSettings()
  'Fixe Einstellungen des ComPorts
  COMPort.COMPort = 0
  COMPort.Settings = "19200,N,8,1"
  COMPort.Handshake = comNone
  COMPort.InputMode = comInputModeText
  
  frmMain.Com.Settings = COMPort.Settings
  frmMain.Com.Handshaking = COMPort.Handshake
  frmMain.Com.InputMode = COMPort.InputMode
  
  '!!!LEERZEICHEN HINTER DEN BEFEHLEN SIND WICHTIG!!!
  'Hardwareadressen
  Hardware.Modul.Heizung.Adresse = "Heizung: "
  Hardware.Modul.Regler.Adresse = "Regler: "
  
  'HIER KEINE LEERZEICHEN MEHR
  'Hardwarebefehle
  Hardware.Modul.Heizung.Befehl_Brennertemp = "tempbrenner"
  Hardware.Modul.Heizung.Befehl_Kesseltemp = "tempkessel"
  Hardware.Modul.Regler.Befehl_Raumtemp = "tempraum"
  
  
  'INI-Werte Laden
  COMPort.COMPort = INI_Eintrag_lesen(INIFile, "Programm", "COMPort")
  Einstellungen.ReloadTime = INI_Eintrag_lesen(INIFile, "Programm", "AkInterval")
  

End Sub

'Kleine Warteschleife ca. 1 Sekunde
Public Sub Warten()
  Dim i As Double
  
  For i = 1 To 1000000
    DoEvents
  Next i
End Sub

'Auf Serielle Schnittstelle warten
Public Function WaitSeriell() As String
  Dim i As Double
  Dim buffer As String
    
  Do
    i = i + 1
    buffer = frmMain.Com.Input
  Loop Until i = 100000 Or buffer <> ""
  
  'Timeout?
  If i = 100000 Then buffer = ""
  'MsgBox buffer
  WaitSeriell = buffer
End Function

'Seriellen String senden
Public Sub SendString(buffer As String)
  Dim i As Integer
  Dim j As Integer

  For i = 1 To Len(buffer)
    'Zeichen senden
    frmMain.Com.Output = Mid(buffer, i, 1)
    For j = 1 To 10
      DoEvents
    Next j
  Next i
  frmMain.Com.Output = Chr(13)
End Sub
