VERSION 5.00
Begin VB.Form frmEinstellungen 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "Einstellungen"
   ClientHeight    =   3015
   ClientLeft      =   7380
   ClientTop       =   4905
   ClientWidth     =   4215
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3015
   ScaleWidth      =   4215
   Begin VB.CommandButton cmd_ok 
      Caption         =   "OK"
      Height          =   495
      Left            =   120
      TabIndex        =   9
      Top             =   2400
      Width           =   1815
   End
   Begin VB.CommandButton cmd_abbrechen 
      Caption         =   "Abbrechen"
      Height          =   495
      Left            =   2160
      TabIndex        =   8
      Top             =   2400
      Width           =   1935
   End
   Begin VB.Frame frame_refresh 
      Caption         =   "Aktualisierung"
      Height          =   1215
      Left            =   0
      TabIndex        =   3
      Top             =   1080
      Width           =   4215
      Begin VB.TextBox txt_reloadtime 
         Height          =   285
         Left            =   1080
         TabIndex        =   5
         Top             =   360
         Width           =   855
      End
      Begin VB.Label Label3 
         Caption         =   "von den Modulen holen."
         Height          =   255
         Left            =   720
         TabIndex        =   7
         Top             =   720
         Width           =   3015
      End
      Begin VB.Label Label2 
         Caption         =   "Sekunden neue Werte"
         Height          =   255
         Left            =   2040
         TabIndex        =   6
         Top             =   405
         Width           =   1695
      End
      Begin VB.Label Label1 
         Caption         =   "Alle "
         Height          =   255
         Left            =   720
         TabIndex        =   4
         Top             =   405
         Width           =   375
      End
   End
   Begin VB.Frame frame_comport 
      Caption         =   "Com Port"
      Height          =   975
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   4215
      Begin VB.ComboBox cmb_comports 
         Height          =   315
         ItemData        =   "frmEinstellungen.frx":0000
         Left            =   1560
         List            =   "frmEinstellungen.frx":0002
         TabIndex        =   1
         ToolTipText     =   "Whlen sie den COM-Port des RS485 Adapters aus"
         Top             =   360
         Width           =   2055
      End
      Begin VB.Label lbl_comport 
         Caption         =   "COM-Port:"
         Height          =   255
         Left            =   720
         TabIndex        =   2
         Top             =   405
         Width           =   735
      End
   End
End
Attribute VB_Name = "frmEinstellungen"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit

Private Sub cmd_abbrechen_Click()
  Unload Me
End Sub

Private Sub cmd_ok_Click()
  'ComPort
  If cmb_comports.Text <> "" Then COMPort.COMPort = Right(cmb_comports.Text, 1)
  
  'Refreshtime
  If txt_reloadtime = "" Then
    MsgBox "Bitte Aktualisierung eintragen"
  Else
    Einstellungen.ReloadTime = Val(txt_reloadtime.Text)
    frmMain.tmr_reload.Interval = Einstellungen.ReloadTime * 1000
    Unload Me
  End If
End Sub

Private Sub Form_Load()
  'ComPorts prfen
  Call Check_ComPorts
  
  txt_reloadtime.Text = Einstellungen.ReloadTime
End Sub

'Vorhandene ComPorts suchen
Private Sub Check_ComPorts()
  Dim i As Integer
  
  'Bei Fehler weiter
  On Error Resume Next
   
  'ComPorts durchgehen, VB untersttzt max. 16 Ports
  For i = 1 To 16
    'Port ffnen
    frmMain.Com.CommPort = i
    frmMain.Com.Settings = "19200,N,8,1"
    frmMain.Com.Handshaking = comNone
    frmMain.Com.InputMode = comInputModeText
    If frmMain.Com.PortOpen Then frmMain.Com.PortOpen = False
    frmMain.Com.PortOpen = True
  
    'Wenn kein Fehler auftritt, dann ist der ComPort vorhanden
    If Err = 0 Then
      frmMain.Com.PortOpen = False
      cmb_comports.AddItem "COM" + Format(i)
    End If
    Err.Clear
  Next i
  
  'Fehlerbehandlung lschen
  On Error GoTo 0
End Sub

Private Sub txt_geschwindigkeit_KeyPress(KeyAscii As Integer)
  'Nur Zahlen
  If KeyAscii < 48 And KeyAscii > 57 Then KeyAscii = 0
End Sub
